//
//  PGSearchService.m
//  XCActionBar
//
//  Created by Pedro Gomes on 11/03/2015.
//  Copyright (c) 2015 Pedro Gomes. All rights reserved.
//

#import "XCActionIndex.h"
#import "XCSearchService.h"
#import "XCSearchStrategy.h"

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
@interface XCSearchService ()

@property (nonatomic,   weak) id<PGActionIndex   > index;
@property (nonatomic, strong) id<XCSearchStrategy> strategy;

@end

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
@implementation XCSearchService

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
- (instancetype)initWithIndex:(id<PGActionIndex>)index
                     strategy:(id<XCSearchStrategy>)strategy
{
    if((self = [super init])) {
        self.index    = index;
        self.strategy = strategy;
    }
    return self;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
- (void)performSearchWithQuery:(NSString *)expression completionHandler:(PGSearchServiceCompletionHandler)completionHandler
{
    NSParameterAssert(completionHandler);
    
    NSArray *results = [self.index lookup:expression];
    completionHandler(results ?: @[]);
    
    TRLog(@"<PerformSearchWithQuery>, <query=%@>, <results=%@>", expression, results);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
- (void)interruptSearches
{
    
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
- (void)updateIndex:(id)index
{

}

@end
